/// @cond EO_CXX_EO_IMPL

inline bool elm::fileselector_button::inwin_mode_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_fileselector_button_inwin_mode_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::fileselector_button::inwin_mode_set(bool value_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_fileselector_button_inwin_mode_set(::efl::eolian::to_c(value_)));
}

inline void elm::fileselector_button::window_size_get(Evas_Coord* width_, Evas_Coord* height_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_fileselector_button_window_size_get(width_, height_));
}

inline void elm::fileselector_button::window_size_set(Evas_Coord width_, Evas_Coord height_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_fileselector_button_window_size_set(width_, height_));
}

inline ::efl::eina::string_view elm::fileselector_button::window_title_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_fileselector_button_window_title_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::fileselector_button::window_title_set(::efl::eina::string_view title_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_fileselector_button_window_title_set(::efl::eolian::to_c(title_)));
}

inline bool eo_cxx::elm::fileselector_button::inwin_mode_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_fileselector_button_inwin_mode_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::fileselector_button::inwin_mode_set(bool value_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_fileselector_button_inwin_mode_set(::efl::eolian::to_c(value_)));
}

inline void eo_cxx::elm::fileselector_button::window_size_get(Evas_Coord* width_, Evas_Coord* height_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_fileselector_button_window_size_get(width_, height_));
}

inline void eo_cxx::elm::fileselector_button::window_size_set(Evas_Coord width_, Evas_Coord height_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_fileselector_button_window_size_set(width_, height_));
}

inline ::efl::eina::string_view eo_cxx::elm::fileselector_button::window_title_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_fileselector_button_window_title_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::fileselector_button::window_title_set(::efl::eina::string_view title_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_fileselector_button_window_title_set(::efl::eolian::to_c(title_)));
}

inline ::eo_cxx::elm::fileselector_button::operator ::elm::fileselector_button() const
{
   return *static_cast<::elm::fileselector_button const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::fileselector_button::operator ::elm::fileselector_button&()
{
   return *static_cast<::elm::fileselector_button*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::fileselector_button::operator ::elm::fileselector_button const&() const
{
   return *static_cast<::elm::fileselector_button const*>(static_cast<void const*>(this));
}

template <typename T>
bool elm_fileselector_button_inwin_mode_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->inwin_mode_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_fileselector_button_inwin_mode_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool value_)
{
   try
      {
         static_cast<T*>(self->this_)->inwin_mode_set(::efl::eolian::to_cxx<bool>(value_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_fileselector_button_window_size_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* width_, Evas_Coord* height_)
{
   try
      {
         static_cast<T*>(self->this_)->window_size_get(width_, height_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_fileselector_button_window_size_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Coord width_, Evas_Coord height_)
{
   try
      {
         static_cast<T*>(self->this_)->window_size_set(width_, height_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::string_view elm_fileselector_button_window_title_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->window_title_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_fileselector_button_window_title_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * title_)
{
   try
      {
         static_cast<T*>(self->this_)->window_title_set(::efl::eolian::to_cxx<::efl::eina::string_view>(title_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::fileselector_button >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::button >::template type<T>
         , virtual operations< ::elm_interface_fileselector >::template type<T>
   {
      virtual bool inwin_mode_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_fileselector_button_inwin_mode_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void inwin_mode_set(bool value_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_fileselector_button_inwin_mode_set(::efl::eolian::to_c(value_)));
      }

      virtual void window_size_get(Evas_Coord* width_, Evas_Coord* height_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_fileselector_button_window_size_get(width_, height_));
      }

      virtual void window_size_set(Evas_Coord width_, Evas_Coord height_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_fileselector_button_window_size_set(width_, height_));
      }

      virtual ::efl::eina::string_view window_title_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_fileselector_button_window_title_get());
            return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void window_title_set(::efl::eina::string_view title_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_fileselector_button_window_title_set(::efl::eolian::to_c(title_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::fileselector_button >
{
   static constexpr int value = 
#if defined(FILESELECTOR_BUTTON_PROTECTED) && defined(FILESELECTOR_BUTTON_BETA)
      6
#elif defined(FILESELECTOR_BUTTON_PROTECTED)
      6
#elif defined(FILESELECTOR_BUTTON_BETA)
      6
#else
      6
#endif
      + operation_description_class_size<::elm::button >::value      + operation_description_class_size<::elm_interface_fileselector >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::fileselector_button>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_fileselector_button_inwin_mode_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_fileselector_button_inwin_mode_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_fileselector_button_inwin_mode_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_fileselector_button_inwin_mode_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_fileselector_button_window_size_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_fileselector_button_window_size_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_fileselector_button_window_size_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_fileselector_button_window_size_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_fileselector_button_window_title_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_fileselector_button_window_title_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_fileselector_button_window_title_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_fileselector_button_window_title_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::button>(), &ops[operation_description_class_size< ::elm::fileselector_button >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_fileselector>(), &ops[operation_description_class_size< ::elm::fileselector_button >::value + operation_description_class_size<::elm::button>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::fileselector_button>)
{
   return (ELM_FILESELECTOR_BUTTON_CLASS);
}

} } }

/// @endcond

